# Waterfall builder catalog (/docs/api/waterfalls/waterfall_catalog)

Every capability with its inputs, normalized output fields, and the endpoints a waterfall can use: price, quality, fill, p50 and rate limits.

`GET /v1/waterfalls/catalog`

```json
{
  "operationId": "waterfall_catalog",
  "summary": "Waterfall builder catalog",
  "description": "Every capability with its inputs, normalized output fields, and the endpoints a waterfall can use: price, quality, fill, p50 and rate limits.",
  "tags": [
    "waterfalls"
  ],
  "security": [
    {
      "bearer": []
    }
  ],
  "responses": {
    "200": {
      "description": "OK",
      "content": {
        "application/json": {
          "schema": {
            "type": "object",
            "properties": {
              "items": {
                "type": "array",
                "items": {
                  "type": "object",
                  "properties": {
                    "id": {
                      "type": "string"
                    },
                    "name": {
                      "type": "string"
                    },
                    "category": {
                      "type": "string"
                    },
                    "summary": {
                      "type": "string"
                    },
                    "inputs": {
                      "type": "array",
                      "items": {
                        "type": "object",
                        "properties": {
                          "name": {
                            "type": "string"
                          },
                          "description": {
                            "type": "string"
                          },
                          "required": {
                            "type": "boolean"
                          }
                        },
                        "required": [
                          "name",
                          "description",
                          "required"
                        ]
                      }
                    },
                    "outputs": {
                      "type": "array",
                      "items": {
                        "type": "string"
                      }
                    },
                    "endpoints": {
                      "type": "array",
                      "items": {
                        "type": "object",
                        "properties": {
                          "id": {
                            "type": "string"
                          },
                          "provider": {
                            "type": "string"
                          },
                          "provider_name": {
                            "type": "string"
                          },
                          "name": {
                            "type": "string"
                          },
                          "mode": {
                            "type": "string"
                          },
                          "pricing_model": {
                            "type": "string"
                          },
                          "quote_micro": {
                            "type": "integer"
                          },
                          "sandbox": {
                            "type": "boolean"
                          },
                          "verified": {
                            "type": "boolean"
                          },
                          "supported": {
                            "type": "boolean"
                          },
                          "p50_ms": {
                            "type": [
                              "number",
                              "null"
                            ]
                          },
                          "fill": {
                            "type": "number"
                          },
                          "score": {
                            "type": "number"
                          },
                          "samples": {
                            "type": "integer"
                          },
                          "rps": {
                            "type": [
                              "number",
                              "null"
                            ]
                          },
                          "burst": {
                            "type": [
                              "number",
                              "null"
                            ]
                          }
                        },
                        "required": [
                          "id",
                          "provider",
                          "provider_name",
                          "name",
                          "mode",
                          "pricing_model",
                          "quote_micro",
                          "sandbox",
                          "verified",
                          "supported",
                          "p50_ms",
                          "fill",
                          "score",
                          "samples",
                          "rps",
                          "burst"
                        ]
                      }
                    }
                  },
                  "required": [
                    "id",
                    "name",
                    "category",
                    "summary",
                    "inputs",
                    "outputs",
                    "endpoints"
                  ]
                }
              }
            },
            "required": [
              "items"
            ]
          }
        }
      }
    },
    "default": {
      "description": "Error",
      "content": {
        "application/json": {
          "schema": {
            "type": "object",
            "properties": {
              "error": {
                "type": "object",
                "properties": {
                  "code": {
                    "type": "string",
                    "enum": [
                      "invalid_request",
                      "unauthorized",
                      "insufficient_balance",
                      "max_cost_exceeded",
                      "scope_denied",
                      "budget_blocked",
                      "not_found",
                      "idempotency_mismatch",
                      "invalid_meta",
                      "rate_limited",
                      "upstream_error",
                      "response_buffer_limit",
                      "provider_capacity_unavailable",
                      "grid_saturated",
                      "upstream_timeout",
                      "conflict",
                      "internal_error",
                      "account_frozen",
                      "strict_filters",
                      "plan_limit_reached",
                      "validation_failed",
                      "deadline_exceeded",
                      "cancelled"
                    ]
                  },
                  "message": {
                    "type": "string"
                  },
                  "request_id": {
                    "type": "string"
                  },
                  "call_id": {
                    "type": "string"
                  },
                  "retry_after_ms": {
                    "type": "integer",
                    "minimum": 0
                  },
                  "details": {
                    "type": "object",
                    "additionalProperties": {}
                  }
                },
                "required": [
                  "code",
                  "message"
                ]
              }
            },
            "required": [
              "error"
            ]
          }
        }
      }
    }
  }
}
```
